// 6.3 test_func2.c
#include <stdio.h>
#include <stdlib.h>

typedef int (*Func)(int,int*) ; // ƥоݴؿ

// ǿ
#define CNT(x) (sizeof(x)/sizeof(x[0]))

typedef struct { 
    int  expected;  // Ԥ
    int  argc;      // θĿ
    int  *argv;     // 
} TestElem;

typedef struct {
    Func         testfunc; // ؿ
    char        *funcname; // ؿ̾
    int          testcnt;  // ƥȥǡĿ
    TestElem    *testdata; // ƥȥǡ
} TestUnit;

// ƥоݴؿ
int add(int,int*);
int sub(int,int*);

// ٥ȥ
int v0[] = { 2, 1}; 
int v1[] = { 2, 3};
int v2[] = { 2, 3, 4};

// addѥƥȥǡ
TestElem add_elem[] = {
     3, CNT(v0), v0,
     5, CNT(v1), v1,
     9, CNT(v2), v2
};

// subѥƥȥǡ
TestElem sub_elem[] = {
     1, CNT(v0), v0, 
    -1, CNT(v1), v1,
    -5, CNT(v2), v2
};

// ƥȥǡ
TestUnit unit[] = {
    add, "add", CNT(add_elem), add_elem,
    sub, "sub", CNT(sub_elem), sub_elem
};

// ñΥƥȴؿ
void test_unit(int n, TestUnit *u) {
    for (int i=0;i<n;i++) {
        Func       f=u[i].testfunc;
        TestElem  *p=u[i].testdata;

        printf("func %s:\n", u[i].funcname);
        for (int j=0;j<u[i].testcnt;j++) {
            printf("test %d: ",j);
            printf("argv=(");
               for (int k=0;k<p[j].argc;k++)
                 printf(" %d", p[j].argv[k]);
            printf(") expected= %d :",p[j].expected);
            int result = (*f)(p[j].argc, p[j].argv);
            if (result != p[j].expected)
                printf("failed\n");
            else
                printf("success\n");
        }
    }
}

// ƥоݤμ
int add(int c,int *v) { 
    int r=v[0]; 
    for(int i=1;i<c;i++) r+=v[i];
    return r;
}

int sub(int c,int *v) { 
    int r=v[0]; 
    for(int i=1;i<c;i++) r-=v[i];
    return r;
}

int main() {
    test_unit(CNT(unit), unit);
    return 0;
}
